<?php
/**
*
* @package phpBB Extension - Like&Dislike
* @copyright (c) 2019 southklad
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/
namespace southklad\likedislike\controller;

/**
 * Add controller.
 */
class add_rate
{
	/** @var \phpbb\auth\auth */
	protected $auth;

	/** @var \phpbb\db\driver\driver */
	protected $db;

	/** @var \phpbb\controller\helper $controller_helper */
	protected $helper;

	/** @var \phpbb\request\request */
	protected $request;

	/** @var \phpbb\user */
	protected $user;

	/** @ \southklad\likedislike\Tables */
	protected $rating_table;

	/** @ \southklad\likedislike\Tables */
	protected $rating_users_table;

	/** @ \southklad\likedislike\Tables */
	protected $rating_topics_table;
	/**
	 * Constructor
	 */
	public function __construct(
		\phpbb\auth\auth $auth,
		\phpbb\config\config $config,
		\phpbb\db\driver\driver_interface $db,
		\phpbb\controller\helper $helper,
		\phpbb\request\request $request,
		\phpbb\user $user,
		$rating_table,
		$rating_users_table,
		$rating_topics_table,
		$rc_helper
	)
	{
		$this->auth = $auth;
		$this->config = $config;
		$this->helper = $helper;
		$this->db = $db;
		$this->request = $request;
		$this->user = $user;
		$this->rating_table = $rating_table;
		$this->rating_users_table = $rating_users_table;
		$this->rating_topics_table = $rating_topics_table;
		$this->rc_helper = $rc_helper;
	}

	/**
	 * controller
	 */
	public function add($post_id, $type_id)
	{
		//$post_id = $this->request->variable('p', 208582);
		$user_id = $this->user->data['user_id'];

		//$type_id = 1;
		//print "User $user_id P $post_id $type_id<br />";

		if ($user_id != ANONYMOUS)
		{
			$post = 0;
			$column = ($type_id) ? ' positiv' : 'negativ';
			$s_positiv = ($type_id) ? 1 : 0;
			$s_negativ = ($type_id) ? 0 : 1;

			$sql = 'SELECT p.post_id, p.positiv, p.negativ, pu.rate_id
				FROM ' . $this->rating_table . ' p
				LEFT JOIN ' . $this->rating_users_table . ' pu ON (pu.rate_user_id = ' . $user_id . ' AND pu.post_rate_id = p.post_id)
					WHERE p.post_id = ' . $post_id;
			$result = $this->db->sql_query($sql);

			$row = $this->db->sql_fetchrow($result);
			$post_rate = $row['rate_id'];
			$post = $row['post_id'];
//print "$sql<br />Post $post<br />";
			$positiv = (isset($row['positiv'])) ? $row['positiv'] : 0;
			$negativ = (isset($row['negativ'])) ? $row['negativ'] : 0;
			$this->db->sql_freeresult($result);

			//$sql = 'SELECT topic_id FROM ' . POSTS_TABLE . ' WHERE post_id = ' . $post_id;
			$sql = 'SELECT p.topic_id, t.topic_rate_id, t.positiv AS plus, t.negativ AS minus
				FROM ' . POSTS_TABLE . ' p
				LEFT JOIN ' . $this->rating_topics_table . ' t ON (p.topic_id = t.topic_rate_id) WHERE post_id = ' . $post_id;
			$result = $this->db->sql_query($sql);
			$row = $this->db->sql_fetchrow($result);
			$topic_id = $row['topic_id'];
			$this->db->sql_freeresult($result);
			//print "$topic_id <br />$sql<br />";

			if ($type_id)
			{
				++$positiv;
				--$negativ;
				if ($negativ < 0)
				{
					$negativ = 0;
				}
			}
			else
			{
				--$positiv;
				++$negativ;
				if ($positiv < 0)
				{
					$positiv = 0;
				}
			}

			if ($post) //  
			{
				if ($type_id == 2) // 
				{
					$this->rc_helper->udate_topic_rating($post_id, $topic_id);
				}
				else // 
				{
					//print "Change post_rate $post_rate<br />";
					if ($post_rate) //  
					{
						$sql = 'UPDATE ' . $this->rating_table . ' SET positiv = ' . $positiv . ', negativ = ' . $negativ . ' WHERE post_id = ' . $post_id . '';
						$this->db->sql_query($sql);
						//print "$sql<br />";
					}
					else
					{
						if ($type_id)
						{

								$negativ = 0;
								$positiv = 1;

						}
						else
						{
								$negativ = 1;
								$positiv = 0;
						}
						//print "Positiv $positiv Negativ $negativ Plus $row[plus] Minus $row[minus]<br />";
						$plus = $row['plus'] + $positiv;
						$sql = 'UPDATE ' . $this->rating_table . '
							SET positiv = ' . $plus . ', negativ = ' . ($row['minus'] + $negativ) . '
							WHERE post_id = ' . $post_id . '';
						$this->db->sql_query($sql);
						//print "$sql<br />";
						$sql = 'UPDATE ' . $this->rating_topics_table . '
							SET positiv = ' . $plus . ', negativ = ' . ($row['minus'] + $negativ) . '
								WHERE topic_rate_id = '. $topic_id;
								//print "Post $post <br />$sql<br />";
						$sql = 'INSERT INTO ' . $this->rating_users_table . ' (rate_user_id, post_rate_id, time_rate, positiv, negativ)
							VALUES (' . $user_id . ', ' . $post_id . ', ' . time() . ', ' . $s_positiv . ', ' . $s_negativ . ')';
						$this->db->sql_query($sql);
						//print "$sql<br />";

					}

// exit;
				}
			}
			else // 
			{
				//print "New";
				$sql = 'SELECT rate_id, positiv, negativ
					FROM ' . $this->rating_topics_table . '
						WHERE topic_rate_id = ' . $topic_id;
				$result = $this->db->sql_query($sql);
				$row = $this->db->sql_fetchrow($result);
				$tid = $row['rate_id'];
				$this->db->sql_freeresult($result);
				$positiv += $row['positiv'];
				$negativ += $row['negativ'];

				if ($tid) //  
				{
					$sql = 'UPDATE ' . $this->rating_topics_table . '
						SET positiv = ' . $positiv . ', negativ = ' . $negativ . '
							WHERE rate_id = '. $tid;
					//$this->db->sql_query($sql);
				}
				else
				{
					$sql = 'INSERT INTO ' . $this->rating_topics_table . ' (topic_rate_id, positiv, negativ)
						VALUES (' . $topic_id . ', ' . $positiv . ', ' . $negativ . ')';
					$this->db->sql_query($sql);
				}
				print"$sql<br />";
				$sql = 'INSERT INTO ' . $this->rating_table . ' (post_id, ' . $column . ', topic_id) VALUES (' . $post_id . ', 1, ' . $topic_id . ')';
				print"$sql<br />";
				$this->db->sql_query($sql);

				$sql = 'INSERT INTO ' . $this->rating_users_table . ' (rate_user_id, post_rate_id, time_rate, positiv, negativ)
					VALUES (' . $user_id . ', ' . $post_id . ', ' . time() . ', ' . $s_positiv . ', ' . $s_negativ . ')';
				print"$sql<br />";
				$this->db->sql_query($sql);
			}

			if ($this->request->is_ajax())
			{
				$json_response = new \phpbb\json_response;
				$data_send = array(
					'success'			=> true,
					'POST_ID'			=> $post_id,
					'ACTION'			=> $type_id,
					//'RATING'			=> $sql,
				);
				return $json_response->send($data_send);
			}
		}
	}
}
