<?php
/**
*
* @package phpBB Extension - Like&Dislike
* @copyright (c) 2019 southklad
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/
namespace southklad\likedislike\controller;

/**
 * Add controller.
 */
class add_rate
{
	/** @var \phpbb\auth\auth */
	protected $auth;

	/** @var \phpbb\db\driver\driver */
	protected $db;

	/** @var \phpbb\controller\helper $controller_helper */
	protected $helper;

	/** @var \phpbb\request\request */
	protected $request;

	/** @var \phpbb\user */
	protected $user;

	/** @ \southklad\likedislike\Tables */
	protected $rating_table;

	/** @ \southklad\likedislike\Tables */
	protected $rating_users_table;

	/** @ \southklad\likedislike\Tables */
	protected $rating_topics_table;
	/**
	 * Constructor
	 */
	public function __construct(
		\phpbb\auth\auth $auth,
		\phpbb\config\config $config,
		\phpbb\db\driver\driver_interface $db,
		\phpbb\controller\helper $helper,
		\phpbb\request\request $request,
		\phpbb\user $user,
		$rating_table,
		$rating_users_table,
		$rating_topics_table,
		$rc_helper
	)
	{
		$this->auth = $auth;
		$this->config = $config;
		$this->helper = $helper;
		$this->db = $db;
		$this->request = $request;
		$this->user = $user;
		$this->rating_table = $rating_table;
		$this->rating_users_table = $rating_users_table;
		$this->rating_topics_table = $rating_topics_table;
		$this->rc_helper = $rc_helper;
	}

	/**
	 * controller
	 */
	public function add($post_id, $type_id)
	{
		//print "$post_id, $type_id<br />";
		$user_id = $this->user->data['user_id'];
		$trigger = false;

		if ($this->user->data['user_id'] != ANONYMOUS)
		{
			$post = 0;
			$column = ($type_id) ? ' positiv' : 'negativ';
			//print "$column<br />";

			$sql = 'SELECT p.post_id, p.positiv, p.negativ, pu.rate_id
				FROM ' . $this->rating_table . ' p
				LEFT JOIN ' . $this->rating_users_table . ' pu ON (pu.rate_user_id = ' . $user_id . ' AND pu.post_rate_id = p.post_id)
					WHERE p.post_id = ' . $post_id;
			$result = $this->db->sql_query($sql);

			$row = $this->db->sql_fetchrow($result);
			$post_rate = $row['rate_id'];
			//print "$sql<br />post $post_rate<br />";
			$post = $row['post_id'];

			$this->db->sql_freeresult($result);

			$sql = 'SELECT p.topic_id, t.topic_rate_id, t.positiv AS plus, t.negativ AS minus
				FROM ' . POSTS_TABLE . ' p
				LEFT JOIN ' . $this->rating_topics_table . ' t ON (p.topic_id = t.topic_rate_id) WHERE post_id = ' . $post_id;
			$result = $this->db->sql_query($sql);
			$row = $this->db->sql_fetchrow($result);
			$topic_id = $row['topic_id'];
			$plus = $row['plus'];
			$minus = $row['minus'];
			$this->db->sql_freeresult($result);
 			//print "Plus $plus Minus $minus<br />";
			$update = ($type_id) ? ' positiv + 1' :  'negativ + 1';
			if ($type_id)
			{
				$s_positiv = 1;
				$s_negativ = 0;
				++$plus;
				--$minus;
				$set = ' positiv = positiv + 1, negativ = negativ - 1';
				//print "Up<br />";
			}
			else
			{
				$s_positiv = 0;
				$s_negativ = 1;
				--$plus;
				++$minus;
				$set = ' positiv = positiv - 1, negativ = negativ + 1';
				//print "Down<br />";
			}
			//print "$set<br />";

			if ($post)
			{
				if ($type_id == 2) // 
				{
					$this->rc_helper->udate_topic_rating($post_id, $topic_id);
				}
				else // 
				{
					//print "Plus $plus Minus $minus<br />";
					if ($post_rate)
					{
						//print "Vote trigger Post rate $post_rate<br />";
						$sql = 'UPDATE ' . $this->rating_users_table . '
							SET time_rate = ' . time() . ', positiv = ' . $s_positiv . ', negativ = ' . $s_negativ . '
							WHERE post_rate_id = ' . $post_id . ' AND rate_user_id = ' . $this->user->data['user_id'] . '';
							//print "$sql<br />";
						$this->db->sql_query($sql);
						$sql = 'UPDATE ' . $this->rating_topics_table . '
							SET positiv = ' . $plus . ', negativ = ' . $minus . ' WHERE topic_rate_id = ' . $topic_id . '';
						$this->db->sql_query($sql);
						//print "$sql<br />";
						//exit;
						$sql = 'UPDATE ' . $this->rating_table . ' SET ' . $set . ' WHERE post_id = ' . $post_id . '';
						$this->db->sql_query($sql);
						//print "$sql<br />";
						$trigger = true;

					}
					else
					{
						//print "No<br />";
						$sql = 'INSERT INTO ' . $this->rating_users_table . ' (rate_user_id, post_rate_id, time_rate, positiv, negativ)
							VALUES (' . $user_id . ', ' . $post_id . ', ' . time() . ', ' . $s_positiv . ', ' . $s_negativ . ')';
						//print"$sql<br />";
						$this->db->sql_query($sql);
						$sql = 'UPDATE ' . $this->rating_table . ' SET ' . $column . ' = ' . $update . ' WHERE post_id = '. $post_id;
						$this->db->sql_query($sql);
						//print"$sql<br />";
						$sql = 'UPDATE ' . $this->rating_topics_table . ' SET ' . $column . ' = ' . $update . ' WHERE topic_rate_id = ' . $topic_id . '';
						//print"$sql<br />";
						$this->db->sql_query($sql);


					}
				}
			}
			else // 
			{
				//print "New<br />";
				$sql = 'SELECT rate_id FROM ' . $this->rating_topics_table . ' WHERE topic_rate_id = ' . $topic_id;
				$result = $this->db->sql_query($sql);
				$tid = $this->db->sql_fetchfield('rate_id');
				$this->db->sql_freeresult($result);
				if ($tid)
				{
					$sql = 'UPDATE ' . $this->rating_topics_table . ' SET ' . $column . ' = ' . $update . ' WHERE topic_rate_id = ' . $topic_id . '';
				}
				else
				{
					$sql = 'INSERT INTO ' . $this->rating_topics_table . ' (topic_rate_id, ' . $column . ') VALUES (' . $topic_id . ', 1)';
				}
				$this->db->sql_query($sql);
				//print "$sql<br />";
				$sql = 'INSERT INTO ' . $this->rating_table . ' (post_id, ' . $column . ', topic_id) VALUES (' . $post_id . ', 1, ' . $topic_id . ')';
				//print"$sql<br />";
				$this->db->sql_query($sql);

				$sql = 'INSERT INTO ' . $this->rating_users_table . ' (rate_user_id, post_rate_id, time_rate, positiv, negativ)
					VALUES (' . $user_id . ', ' . $post_id . ', ' . time() . ', ' . $s_positiv . ', ' . $s_negativ . ')';
				//print"$sql<br />";
				$this->db->sql_query($sql);
			}
			//exit;

			if ($this->request->is_ajax())
			{
				$json_response = new \phpbb\json_response;
				$data_send = array(
					'success'			=> true,
					'POST_ID'			=> $post_id,
					'ACTION'			=> $type_id,
					'update'			=> $trigger,
				);
				return $json_response->send($data_send);
			}
		}
	}
}
