<?php
/**
*
* @package phpBB Extension - Like&Dislike
* @copyright (c) 2019 southklad
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/
namespace southklad\likedislike\migrations;

class likedislike_1_0_0 extends \phpbb\db\migration\migration
{
	public function effectively_installed()
	{
		return;
	}

	static public function depends_on()
	{
		return array('\phpbb\db\migration\data\v320\v320');
	}

	public function update_schema()
	{
		return array(
			'add_tables'		=> array(
				$this->table_prefix . 'rate_posts'	=> array(
					'COLUMNS'			=> array(
						'rate_id'		=> array('UINT', null, 'auto_increment'),
						'post_id'		=> array('UINT', 0),
						'topic_id'		=> array('UINT', 0),
						'positiv'		=> array('UINT', 0),
						'negativ'		=> array('UINT', 0),
					),
					'PRIMARY_KEY'	=> 'rate_id',
				),
				$this->table_prefix . 'rate_users'	=> array(
					'COLUMNS'			=> array(
						'rate_id'		=> array('UINT', null, 'auto_increment'),
						'rate_user_id'	=> array('UINT', 0),
						'post_rate_id'	=> array('UINT', 0),
						'positiv'		=> array('BOOL', 0),
						'negativ'		=> array('BOOL', 0),
						'time_rate'		=> array('TIMESTAMP', 0),
					),
					'PRIMARY_KEY'	=> 'rate_id',
				),
				$this->table_prefix . 'rate_topics'	=> array(
					'COLUMNS'			=> array(
						'rate_id'		=> array('UINT', null, 'auto_increment'),
						'topic_rate_id'	=> array('UINT', 0),
						'positiv'		=> array('UINT', 0),
						'negativ'		=> array('UINT', 0),
					),
					'PRIMARY_KEY'	=> 'rate_id',
				),
			),
		);
	}

	public function revert_schema()
	{
		return array(
			'drop_tables'		=> array(
				$this->table_prefix . 'rate_posts',
				$this->table_prefix . 'rate_users',
				$this->table_prefix . 'rate_topics',
			),
		);
	}

	public function update_data()
	{
		return array(
			// Current version
			array('config.add', array('likedislike_version', '1.0.0')),
			array('config.add', array('likedislike_flood', '900')),
		);
	}
}